wxWidgets: wxMemoryInputStream Class Reference

| Version: 3.0.5

Public Member Functions | List of all members
wxMemoryInputStream Class Reference
Class List by Category » Streams

`#include </home/Hamis/wxwidgets/wxWidgets3.0/wxWidgets3.0-3.0.5.1-2.i686/src/wxWidgets-3.0.5.1/interface/wx/mstream.h>`

Inheritance diagram for wxMemoryInputStream:
[legend]

## Detailed Description

This class allows using all methods taking a wxInputStream reference to read in-memory data.

Example:

// we've got a block of memory containing a BMP image and we want
// to use wxImage to load it:
wxMemoryInputStream stream(my_memory_block, size);
wxImage theBitmap;
if (!theBitmap.LoadFile(stream, wxBITMAP_TYPE_BMP))
return;
// we can now safely delete the original memory buffer as the data
// has been decoded by wxImage:
delete [] my_memory_block;
wxImage
This class encapsulates a platform-independent image.
Definition: image.h:472
wxImage::LoadFile
virtual bool LoadFile(wxInputStream &stream, wxBitmapType type=wxBITMAP_TYPE_ANY, int index=-1)
Loads an image from an input stream.
wxMemoryInputStream
This class allows using all methods taking a wxInputStream reference to read in-memory data.
Definition: mstream.h:99
wxBITMAP_TYPE_BMP
@ wxBITMAP_TYPE_BMP
Definition: gdicmn.h:15

##

Library: wxBase

<>< =''>:</>&;&;< =''>\ </></>

See also
  wxStreamBuffer, wxMemoryOutputStream

## Public Member Functions
| wxMemoryInputStream (const void *data, size_t len)
| Initializes a new read-only memory stream which will use the specified buffer data of length len. More...
| wxMemoryInputStream (const wxMemoryOutputStream &stream)
| Creates a new read-only memory stream, initializing it with the data from the given output stream stream. More...
| wxMemoryInputStream (wxInputStream &stream, wxFileOffset len=wxInvalidOffset)
| Creates a new read-only memory stream, initializing it with the data from the given input stream stream. More...
virtual | ~wxMemoryInputStream ()
| Destructor. More...
wxStreamBuffer * | GetInputStreamBuffer () const
| Returns the pointer to the stream object used as an internal buffer for that stream. More...
Public Member Functions inherited from wxInputStream
| wxInputStream ()
| Creates a dummy input stream. More...
virtual | ~wxInputStream ()
| Destructor. More...
virtual bool | CanRead () const
| Returns true if some data is available in the stream right now, so that calling Read() wouldn't block. More...
virtual bool | Eof () const
| Returns true after an attempt has been made to read past the end of the stream. More...
int | GetC ()
| Returns the first character in the input queue and removes it, blocking until it appears if necessary. More...
virtual size_t | LastRead () const
| Returns the last number of bytes read. More...
virtual char | Peek ()
| Returns the first character in the input queue without removing it. More...
virtual wxInputStream & | Read (void *buffer, size_t size)
| Reads the specified amount of bytes and stores the data in buffer. More...
wxInputStream & | Read (wxOutputStream &stream_out)
| Reads data from the input queue and stores it in the specified output stream. More...
bool | ReadAll (void *buffer, size_t size)
| Reads exactly the specified number of bytes into the buffer. More...
virtual wxFileOffset | SeekI (wxFileOffset pos, wxSeekMode mode=wxFromStart)
| Changes the stream current position. More...
virtual wxFileOffset | TellI () const
| Returns the current stream position or wxInvalidOffset if it's not available (e.g. More...
size_t | Ungetch (const void *buffer, size_t size)
| This function is only useful in read mode. More...
bool | Ungetch (char c)
| This function acts like the previous one except that it takes only one character: it is sometimes shorter to use than the generic function. More...
Public Member Functions inherited from wxStreamBase
| wxStreamBase ()
| Creates a dummy stream object. More...
virtual | ~wxStreamBase ()
| Destructor. More...
wxStreamError | GetLastError () const
| This function returns the last error. More...
virtual wxFileOffset | GetLength () const
| Returns the length of the stream in bytes. More...
virtual size_t | GetSize () const
| This function returns the size of the stream. More...
virtual bool | IsOk () const
| Returns true if no error occurred on the stream. More...
virtual bool | IsSeekable () const
| Returns true if the stream supports seeking to arbitrary offsets. More...
void | Reset (wxStreamError error=wxSTREAM_NO_ERROR)
| Resets the stream state. More...
bool | operator! () const
| Returns the opposite of IsOk(). More...

## Additional Inherited Members
Protected Member Functions inherited from wxInputStream
size_t | OnSysRead (void *buffer, size_t bufsize)=0
| Internal function. More...
Protected Member Functions inherited from wxStreamBase
virtual wxFileOffset | OnSysSeek (wxFileOffset pos, wxSeekMode mode)
| Internal function. More...
virtual wxFileOffset | OnSysTell () const
| Internal function. More...

## Constructor & Destructor Documentation

## ◆ wxMemoryInputStream() [1/3]

wxMemoryInputStream::wxMemoryInputStream | ( | const void * | data,
|  | size_t | len
| ) |  |

Initializes a new read-only memory stream which will use the specified buffer data of length len.

The stream does not take ownership of the buffer, i.e. the buffer will not be deleted in its destructor.

## ◆ wxMemoryInputStream() [2/3]

wxMemoryInputStream::wxMemoryInputStream | ( | const wxMemoryOutputStream & | stream | ) |

Creates a new read-only memory stream, initializing it with the data from the given output stream stream.

## ◆ wxMemoryInputStream() [3/3]

wxMemoryInputStream::wxMemoryInputStream | ( | wxInputStream & | stream,
|  | wxFileOffset | len = `wxInvalidOffset`
| ) |  |

Creates a new read-only memory stream, initializing it with the data from the given input stream stream.

The len argument specifies the amount of data to read from the stream. Setting it to wxInvalidOffset means that the stream is to be read entirely (i.e. till the EOF is reached).

## ◆ ~wxMemoryInputStream()

virtual wxMemoryInputStream::~wxMemoryInputStream | ( |  | ) |
| virtual

Destructor.

Does NOT free the buffer provided in the ctor.

## Member Function Documentation

## ◆ GetInputStreamBuffer()

wxStreamBuffer* wxMemoryInputStream::GetInputStreamBuffer | ( |  | ) | const

Returns the pointer to the stream object used as an internal buffer for that stream.